freedombone-image-customise 56KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025102610271028102910301031103210331034103510361037103810391040104110421043104410451046104710481049105010511052105310541055105610571058105910601061106210631064106510661067106810691070107110721073107410751076107710781079108010811082108310841085108610871088108910901091109210931094109510961097109810991100110111021103110411051106110711081109111011111112111311141115111611171118111911201121112211231124112511261127112811291130113111321133113411351136113711381139114011411142114311441145114611471148114911501151115211531154115511561157115811591160116111621163116411651166116711681169117011711172117311741175117611771178117911801181118211831184118511861187118811891190119111921193119411951196119711981199120012011202120312041205120612071208120912101211121212131214121512161217121812191220122112221223122412251226122712281229123012311232123312341235123612371238123912401241124212431244124512461247124812491250125112521253125412551256125712581259126012611262126312641265126612671268126912701271127212731274127512761277127812791280128112821283128412851286128712881289129012911292129312941295129612971298129913001301130213031304130513061307130813091310131113121313131413151316131713181319132013211322132313241325132613271328132913301331133213331334133513361337133813391340134113421343134413451346134713481349135013511352135313541355135613571358135913601361136213631364136513661367136813691370137113721373137413751376137713781379138013811382138313841385138613871388138913901391139213931394139513961397139813991400140114021403140414051406140714081409141014111412141314141415141614171418141914201421142214231424142514261427142814291430143114321433143414351436143714381439144014411442144314441445144614471448144914501451145214531454145514561457
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # Based on bin/freedombox-customize from freedom-maker
  12. #
  13. # License
  14. # =======
  15. #
  16. # This program is free software: you can redistribute it and/or modify
  17. # it under the terms of the GNU Affero General Public License as published by
  18. # the Free Software Foundation, either version 3 of the License, or
  19. # (at your option) any later version.
  20. #
  21. # This program is distributed in the hope that it will be useful,
  22. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  23. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  24. # GNU Affero General Public License for more details.
  25. #
  26. # You should have received a copy of the GNU Affero General Public License
  27. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  28. set -e
  29. set -x
  30. PROJECT_NAME='freedombone'
  31. INSTALL_DIR=/root/build
  32. COMPLETION_FILE=$HOME/${PROJECT_NAME}-completed.txt
  33. PROJECT_REPO="https://github.com/bashrc/${PROJECT_NAME}"
  34. VARIANT='full'
  35. # username created by default within a debian image
  36. GENERIC_IMAGE_USERNAME='fbone'
  37. export TEXTDOMAIN=${PROJECT_NAME}-image-customise
  38. export TEXTDOMAINDIR="/usr/share/locale"
  39. # Whether to minimise the number of decisions during interactive install
  40. MINIMAL_INSTALL="yes"
  41. MY_USERNAME='debian'
  42. MY_PASSWORD="${PROJECT_NAME}"
  43. # Minimum number of characters in a password
  44. MINIMUM_PASSWORD_LENGTH=10
  45. # IP address of the router (gateway)
  46. ROUTER_IP_ADDRESS="192.168.1.254"
  47. # The fixed IP address of the Beaglebone Black on your local network
  48. BOX_IP_ADDRESS="192.168.1.55"
  49. # DNS
  50. NAMESERVER1='213.73.91.35'
  51. NAMESERVER2='85.214.20.141'
  52. # optional configuration file containing freedombone settings
  53. CONFIG_FILENAME=
  54. # Optional ssh public key to allow
  55. SSH_PUBKEY="no"
  56. # Whether this is a generic image for mass redistribution on the interwebs
  57. GENERIC_IMAGE="no"
  58. # default SSH port
  59. SSH_PORT=2222
  60. # for mesh installs
  61. TRACKER_PORT=6969
  62. # Whether sites are accessible only within a Tor browser
  63. ONION_ONLY="no"
  64. # Whether to only install debian and nothing else
  65. DEBIAN_INSTALL_ONLY="no"
  66. # wifi settings
  67. WIFI_INTERFACE='wlan0'
  68. WIFI_SSID=
  69. WIFI_TYPE='wpa2-psk'
  70. WIFI_PASSPHRASE=
  71. WIFI_HOTSPOT='no'
  72. WIFI_NETWORKS_FILE=~/${PROJECT_NAME}-wifi.cfg
  73. # Whether to install non-free wifi drivers for the mesh client
  74. INSECURE='no'
  75. # optional desktop background image for mesh
  76. MESH_DESKTOP_BACKGROUND_IMAGE=/usr/local/share/${PROJECT_NAME}_mesh_background.png
  77. # The browser application to use
  78. BROWSER=iceweasel
  79. MESH_INSTALL_DIR=/var/lib
  80. enable_eatmydata_override() {
  81. chroot $rootdir apt-get install --no-install-recommends -y eatmydata
  82. if [ -x $rootdir/usr/bin/eatmydata ] && \
  83. [ ! -f $rootdir/etc/apt/apt.conf.d/95debian-edu-install-dpkg-eatmydata ]; then
  84. echo $"info: Adding apt config to call dpkg via eatmydata"
  85. printf "#!/bin/sh\nexec eatmydata dpkg \"\$@\"\n" \
  86. > $rootdir/var/tmp/dpkg-eatmydata
  87. chmod 755 $rootdir/var/tmp/dpkg-eatmydata
  88. cat > $rootdir/etc/apt/apt.conf.d/95debian-edu-install-dpkg-eatmydata <<EOF
  89. Dir::Bin::dpkg "/var/tmp/dpkg-eatmydata";
  90. EOF
  91. else
  92. echo $"error: unable to find /usr/bin/eatmydata after installing the eatmydata package"
  93. fi
  94. }
  95. disable_eatmydata_override() {
  96. for override in \
  97. /etc/apt/apt.conf.d/95debian-edu-install-dpkg-eatmydata \
  98. /var/tmp/dpkg-eatmydata ; do
  99. echo $"info: Removing apt config to call dpkg via eatmydata"
  100. if [ -f $rootdir$override ] ; then
  101. rm -f $rootdir$override
  102. else
  103. echo $"warning: missing $rootdir$override"
  104. fi
  105. done
  106. sync # Flush file buffers before continuing
  107. }
  108. set_apt_sources() {
  109. NEW_MIRROR="$1"
  110. COMPONENTS="main"
  111. cat <<EOF > etc/apt/sources.list
  112. deb $NEW_MIRROR $SUITE $COMPONENTS
  113. deb-src $NEW_MIRROR $SUITE $COMPONENTS
  114. #deb http://security.debian.org/ $SUITE/updates main
  115. #deb-src http://security.debian.org/ $SUITE/updates main
  116. EOF
  117. }
  118. configure_networking() {
  119. if [[ $DEBIAN_INSTALL_ONLY != "no" ]]; then
  120. return
  121. fi
  122. if [[ $GENERIC_IMAGE == "no" ]]; then
  123. echo "# This file describes the network interfaces available on your system
  124. # and how to activate them. For more information, see interfaces(5).
  125. # The loopback network interface
  126. auto lo
  127. iface lo inet loopback
  128. # The primary network interface
  129. auto eth0
  130. iface eth0 inet static
  131. address $BOX_IP_ADDRESS
  132. netmask 255.255.255.0
  133. gateway $ROUTER_IP_ADDRESS
  134. dns-nameservers $NAMESERVER1 $NAMESERVER2
  135. # Example to keep MAC address between reboots
  136. #hwaddress ether B5:A2:BE:3F:1A:FE
  137. # The secondary network interface
  138. #auto eth1
  139. #iface eth1 inet dhcp
  140. # WiFi Example
  141. #auto wlan0
  142. #iface wlan0 inet dhcp
  143. # wpa-ssid \"essid\"
  144. # wpa-psk \"password\"
  145. # Ethernet/RNDIS gadget (g_ether)
  146. # ... or on host side, usbnet and random hwaddr
  147. # Note on some boards, usb0 is automaticly setup with an init script
  148. #iface usb0 inet static
  149. # address 192.168.7.2
  150. # netmask 255.255.255.0
  151. # network 192.168.7.0
  152. # gateway 192.168.7.1" > $rootdir/etc/network/interfaces
  153. hexarray=( 1 2 3 4 5 6 7 8 9 0 a b c d e f )
  154. a=${hexarray[$RANDOM%16]}${hexarray[$RANDOM%16]}
  155. b=${hexarray[$RANDOM%16]}${hexarray[$RANDOM%16]}
  156. c=${hexarray[$RANDOM%16]}${hexarray[$RANDOM%16]}
  157. d=${hexarray[$RANDOM%16]}${hexarray[$RANDOM%16]}
  158. e=${hexarray[$RANDOM%16]}${hexarray[$RANDOM%16]}
  159. sed -i "s|#hwaddress ether.*|hwaddress ether de:$a:$b:$c:$d:$e|g" \
  160. $rootdir/etc/network/interfaces
  161. fi
  162. sed -i "s/nameserver.*/nameserver $NAMESERVER1/g" $rootdir/etc/resolv.conf
  163. sed -i "/nameserver $NAMESERVER1/a\nameserver $NAMESERVER2" $rootdir/etc/resolv.conf
  164. if [[ $VARIANT != "meshclient" && $VARIANT != "meshusb" ]]; then
  165. # change the motd to show further install instructions
  166. echo $"
  167. .---. . .
  168. | | |
  169. |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  170. | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  171. ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  172. Initial base install
  173. Your system is not yet installed. To complete the process run the
  174. following commands, then enter your details.
  175. sudo su
  176. ${PROJECT_NAME} menuconfig
  177. " > $rootdir/etc/motd
  178. else
  179. echo $"
  180. .---. . .
  181. | | |
  182. |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  183. | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  184. ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  185. Freedom in the Mesh
  186. " > $rootdir/etc/motd
  187. fi
  188. }
  189. configure_ssh() {
  190. sed -i "s/Port .*/Port ${SSH_PORT}/g" $rootdir/etc/ssh/sshd_config
  191. if [[ "$SSH_PUBKEY" != "no" ]]; then
  192. if [ ! -d $rootdir/home/$MY_USERNAME/.ssh ]; then
  193. mkdir $rootdir/home/$MY_USERNAME/.ssh
  194. fi
  195. echo "$SSH_PUBKEY" > $rootdir/home/$MY_USERNAME/.ssh/authorized_keys
  196. chroot $rootdir chown -R $MY_USERNAME:$MY_USERNAME /home/$MY_USERNAME/.ssh
  197. sed -i 's|PasswordAuthentication.*|PasswordAuthentication no|g' $rootdir/etc/ssh/sshd_config
  198. echo $"Using ssh public key:"
  199. echo $SSH_PUBKEY
  200. echo $'Password ssh authentication turned off'
  201. fi
  202. }
  203. admin_user_sudo() {
  204. echo "$MY_USERNAME ALL=(ALL) ALL" >> $rootdir/etc/sudoers
  205. }
  206. create_generic_image() {
  207. if [[ $DEBIAN_INSTALL_ONLY != "no" ]]; then
  208. return
  209. fi
  210. if [[ $GENERIC_IMAGE == "no" ]]; then
  211. return
  212. fi
  213. if [ $CONFIG_FILENAME ]; then
  214. if [[ "$CONFIG_FILENAME" == *"mesh.cfg"* ]]; then
  215. VARIANT="mesh"
  216. fi
  217. fi
  218. # Don't install any configuration. This will be a base system
  219. if [[ $VARIANT != "mesh" && $VARIANT != "meshclient" && $VARIANT != "meshusb" ]]; then
  220. CONFIG_FILENAME=
  221. else
  222. touch $rootdir/root/.initial_mesh_setup
  223. fi
  224. # Stick with the existing login for mesh clients
  225. if [[ $VARIANT == "meshclient" || $VARIANT == "meshusb" ]]; then
  226. return
  227. fi
  228. # The presence of this file indicates that the initial
  229. # setup has not yet been completed
  230. touch $rootdir/home/$MY_USERNAME/.initial_setup
  231. chroot $rootdir chown $MY_USERNAME:$MY_USERNAME /home/$MY_USERNAME/.initial_setup
  232. touch $rootdir/root/.initial_setup
  233. cat >> $rootdir/home/$MY_USERNAME/.bashrc <<EOF
  234. # initial setup of the system
  235. if [ -f ~/.initial_setup ]; then
  236. clear
  237. echo "
  238. .---. . .
  239. | | |
  240. |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  241. | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  242. ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  243. Initial setup process
  244. Please enter your password a second time.
  245. "
  246. sudo su
  247. fi
  248. EOF
  249. echo '# initial setup of the system' >> $rootdir/root/.bashrc
  250. echo 'if [ -f ~/.initial_setup ]; then' >> $rootdir/root/.bashrc
  251. echo ' if [ -f ~/login.txt ]; then' >> $rootdir/root/.bashrc
  252. echo ' NEW_USER_PASSWORD=$(printf `cat ~/login.txt`)' >> $rootdir/root/.bashrc
  253. echo ' else' >> $rootdir/root/.bashrc
  254. echo ' ENTROPY=$(cat /proc/sys/kernel/random/entropy_avail)' >> $rootdir/root/.bashrc
  255. echo ' if [ $ENTROPY -lt 500 ]; then' >> $rootdir/root/.bashrc
  256. ENTROPY_MESSAGE1=$'Initial setup process'
  257. ENTROPY_MESSAGE2=$'Password Generation'
  258. ENTROPY_MESSAGE3=$'WARNING: The entropy available on this system is too low to generate a password.\n\nThe installation process cannot continue.'
  259. echo " dialog --backtitle \"${ENTROPY_MESSAGE1}\" --title \"${ENTROPY_MESSAGE2}\" --msgbox \"${ENTROPY_MESSAGE3}\" 8 50" >> $rootdir/root/.bashrc
  260. echo ' exit' >> $rootdir/root/.bashrc
  261. echo ' fi' >> $rootdir/root/.bashrc
  262. echo -n ' NEW_USER_PASSWORD="$(openssl rand -base64 30 | cut -c1-' >> $rootdir/root/.bashrc
  263. echo "${MINIMUM_PASSWORD_LENGTH})\"" >> $rootdir/root/.bashrc
  264. echo ' fi' >> $rootdir/root/.bashrc
  265. echo ' echo "${NEW_USER_PASSWORD}" > ~/login.txt' >> $rootdir/root/.bashrc
  266. echo ' clear' >> $rootdir/root/.bashrc
  267. echo ' echo ""' >> $rootdir/root/.bashrc
  268. NEW_LOGIN_PASSWORD_MESSAGE1=$'Your new login password is:'
  269. NEW_LOGIN_PASSWORD_MESSAGE2=$'Use it whenever you wish to ssh into this system.'
  270. NEW_LOGIN_PASSWORD_MESSAGE3=$'IMPORTANT: Please take a moment to enter the above password into a\npassword manager or write it down somewhere.'
  271. PRESS_KEY_MESSAGE=$'Press any key to continue...'
  272. echo " echo \"${NEW_LOGIN_PASSWORD_MESSAGE1}\"" >> $rootdir/root/.bashrc
  273. echo ' echo ""' >> $rootdir/root/.bashrc
  274. echo ' toilet "${NEW_USER_PASSWORD}"' >> $rootdir/root/.bashrc
  275. echo ' echo ""' >> $rootdir/root/.bashrc
  276. echo ' echo " ${NEW_USER_PASSWORD}"' >> $rootdir/root/.bashrc
  277. echo ' echo ""' >> $rootdir/root/.bashrc
  278. echo " echo \"${NEW_LOGIN_PASSWORD_MESSAGE2}\"" >> $rootdir/root/.bashrc
  279. echo ' echo ""' >> $rootdir/root/.bashrc
  280. echo " echo \"${NEW_LOGIN_PASSWORD_MESSAGE3}\"" >> $rootdir/root/.bashrc
  281. echo ' echo ""' >> $rootdir/root/.bashrc
  282. echo " read -n1 -r -p \"${PRESS_KEY_MESSAGE}\" key" >> $rootdir/root/.bashrc
  283. # change the password for the admin user
  284. echo -n " echo \"${MY_USERNAME}:" >> $rootdir/root/.bashrc
  285. echo '$(printf `cat ~/login.txt`)"|chpasswd' >> $rootdir/root/.bashrc
  286. # update before continuing
  287. echo " cd /root/${PROJECT_NAME}" >> $rootdir/root/.bashrc
  288. echo " git stash" >> $rootdir/root/.bashrc
  289. echo " git pull" >> $rootdir/root/.bashrc
  290. echo " make install" >> $rootdir/root/.bashrc
  291. if [[ $VARIANT != "mesh" && $VARIANT != "meshclient" && $VARIANT != "meshusb" && $VARIANT != "usb" ]]; then
  292. if [[ $ONION_ONLY == "no" ]]; then
  293. if [[ $MINIMAL_INSTALL == "no" ]]; then
  294. echo " ${PROJECT_NAME} menuconfig-full" >> $rootdir/root/.bashrc
  295. else
  296. echo " ${PROJECT_NAME} menuconfig" >> $rootdir/root/.bashrc
  297. fi
  298. else
  299. echo " ${PROJECT_NAME} menuconfig-onion" >> $rootdir/root/.bashrc
  300. fi
  301. else
  302. echo " echo ''" >> $rootdir/root/.bashrc
  303. fi
  304. echo ' if [ "$?" = "0" ]; then' >> $rootdir/root/.bashrc
  305. echo " if [ -f ~/${PROJECT_NAME}-completed.txt ]; then" >> $rootdir/root/.bashrc
  306. # Remove the initial setup files
  307. echo ' rm /root/.initial_setup' >> $rootdir/root/.bashrc
  308. echo " rm /home/${MY_USERNAME}/.initial_setup" >> $rootdir/root/.bashrc
  309. echo " touch /root/.remove_${GENERIC_IMAGE_USERNAME}" >> $rootdir/root/.bashrc
  310. echo ' shred -zu ~/login.txt' >> $rootdir/root/.bashrc
  311. END_MESSAGE1=$'Congratulations!'
  312. if [[ $VARIANT != "mesh" && $VARIANT != "meshclient" && $VARIANT != "meshusb" && $VARIANT != "usb" ]]; then
  313. END_MESSAGE2=$'\nYour system has now installed\n\nThe onion ssh service is at $SSH_ONION_HOSTNAME\n\nPress any key to reboot and begin using it'
  314. echo ' SSH_ONION_HOSTNAME=$(cat /var/lib/tor/hidden_service_ssh/hostname)' >> $rootdir/root/.bashrc
  315. else
  316. END_MESSAGE2=$'\nYour system has now installed\n\nPress any key to reboot and begin using it'
  317. fi
  318. echo " dialog --title '$END_MESSAGE1' --msgbox \"$END_MESSAGE2\" 9 50" >> $rootdir/root/.bashrc
  319. echo ' reboot' >> $rootdir/root/.bashrc
  320. echo ' fi' >> $rootdir/root/.bashrc
  321. echo ' else' >> $rootdir/root/.bashrc
  322. echo ' key=' >> $rootdir/root/.bashrc
  323. echo ' while [[ $key != "x" ]]; do' >> $rootdir/root/.bashrc
  324. INSTALL_FAIL_MESSAGE=$"Install failed. Press x to continue..."
  325. echo " read -n1 -r -p \"${INSTALL_FAIL_MESSAGE}\" key" >> $rootdir/root/.bashrc
  326. echo ' done' >> $rootdir/root/.bashrc
  327. echo ' fi' >> $rootdir/root/.bashrc
  328. echo ' exit' >> $rootdir/root/.bashrc
  329. echo 'else' >> $rootdir/root/.bashrc
  330. echo ' # Remove default account after install' >> $rootdir/root/.bashrc
  331. echo " if [ -f /root/.remove_${GENERIC_IMAGE_USERNAME} ]; then" >> $rootdir/root/.bashrc
  332. echo " if [ -d /home/${GENERIC_IMAGE_USERNAME} ]; then" >> $rootdir/root/.bashrc
  333. echo " userdel -r ${GENERIC_IMAGE_USERNAME}" >> $rootdir/root/.bashrc
  334. echo " if [ -d /home/${GENERIC_IMAGE_USERNAME} ]; then" >> $rootdir/root/.bashrc
  335. echo " rm -rf /home/${GENERIC_IMAGE_USERNAME}" >> $rootdir/root/.bashrc
  336. echo " rm /root/.remove_${GENERIC_IMAGE_USERNAME}" >> $rootdir/root/.bashrc
  337. echo ' fi' >> $rootdir/root/.bashrc
  338. echo ' fi' >> $rootdir/root/.bashrc
  339. echo ' fi' >> $rootdir/root/.bashrc
  340. echo 'fi' >> $rootdir/root/.bashrc
  341. }
  342. continue_installation() {
  343. # If a configuration file exists then run with it
  344. # otherwise the interactive installer can be used
  345. # This is equivalent to installing freedombox-setup on freedombox
  346. if [ $CONFIG_FILENAME ]; then
  347. if [ ${#CONFIG_FILENAME} -gt 2 ]; then
  348. cp $CONFIG_FILENAME $rootdir/root/$PROJECT_NAME.cfg
  349. cat $rootdir/root/$PROJECT_NAME.cfg
  350. chroot "$rootdir" su -c "$PROJECT_NAME -c /root/$PROJECT_NAME.cfg" - root
  351. fi
  352. fi
  353. }
  354. atheros_wifi() {
  355. firmware_filename="open-ath9k-htc-firmware_1.3-1_all.deb"
  356. firmware_hash='5fea58ffefdf0ef15b504db7fbe3bc078c03e0d927bba64085e4b6f2546102f5'
  357. firmware_url="http://us.archive.trisquel.info/trisquel/pool/main/o/open-ath9k-htc-firmware/$firmware_filename"
  358. firmware_tempfile="/tmp/$firmware_filename"
  359. wget "$firmware_url" -O "$rootdir$firmware_tempfile"
  360. downloaded_firmware_hash=$(sha256sum "$rootdir$firmware_tempfile" | awk -F ' ' '{print $1}')
  361. if [[ "$downloaded_firmware_hash" == "$firmware_hash" ]]; then
  362. chroot "$rootdir" dpkg -i "$firmware_tempfile"
  363. else
  364. echo 'WARNING: Atheros Wifi firmware hash does not match. The driver has not been installed.'
  365. fi
  366. }
  367. configure_wifi() {
  368. if [[ $VARIANT == "mesh" || $VARIANT == "meshclient" || $VARIANT == "meshusb" ]]; then
  369. return
  370. fi
  371. if [ -f $WIFI_NETWORKS_FILE ]; then
  372. chroot "$rootdir" ${PROJECT_NAME}-wifi -i $WIFI_INTERFACE --networks $WIFI_NETWORKS_FILE
  373. return
  374. fi
  375. if [[ $WIFI_TYPE != 'none' ]]; then
  376. if [ ${#WIFI_PASSPHRASE} -lt 2 ]; then
  377. return
  378. fi
  379. chroot "$rootdir" ${PROJECT_NAME}-wifi -i $WIFI_INTERFACE -s $WIFI_SSID -t $WIFI_TYPE -p $WIFI_PASSPHRASE --hotspot $WIFI_HOTSPOT
  380. else
  381. chroot "$rootdir" ${PROJECT_NAME}-wifi -i $WIFI_INTERFACE -s $WIFI_SSID -t $WIFI_TYPE --hotspot $WIFI_HOTSPOT
  382. fi
  383. }
  384. ##############################################################################
  385. # Mesh networking
  386. ##############################################################################
  387. # for mesh installs
  388. TRACKER_PORT=6969
  389. WIFI_CHANNEL=2
  390. # B.A.T.M.A.N settings
  391. BATMAN_CELLID='02:BA:00:00:03:01'
  392. WIFI_SSID='mesh'
  393. # To avoid confusions these are obtained from the main project file
  394. TOXID_REPO=
  395. TOX_PORT=
  396. TOXCORE_REPO=
  397. TOXIC_REPO=
  398. TOXCORE_COMMIT=
  399. TOXIC_COMMIT=
  400. # These are some default nodes, but you can replace them with trusted nodes
  401. # as you prefer. See https://wiki.tox.im/Nodes
  402. TOX_NODES=
  403. #TOX_NODES=(
  404. # '192.254.75.102,2607:5600:284::2,33445,951C88B7E75C867418ACDB5D273821372BB5BD652740BCDF623A4FA293E75D2F,Tox RELENG,US'
  405. # '144.76.60.215,2a01:4f8:191:64d6::1,33445,04119E835DF3E78BACF0F84235B300546AF8B936F035185E2A8E9E0A67C8924F,sonOfRa,DE'
  406. #)
  407. # To avoid confusions these are obtained from the main project file
  408. ZERONET_REPO=
  409. ZERONET_COMMIT=
  410. ZERONET_PORT=
  411. ZERONET_BLOG_REPO=
  412. ZERONET_BLOG_COMMIT=
  413. ZERONET_MAIL_REPO=
  414. ZERONET_MAIL_COMMIT=
  415. ZERONET_FORUM_REPO=
  416. ZERONET_FORUM_COMMIT=
  417. ZERONET_ID_REPO=
  418. ZERONET_ID_COMMIT=
  419. # Directory where source code is downloaded and compiled
  420. INSTALL_DIR=$HOME/build
  421. function mesh_avahi {
  422. chroot "$rootdir" apt-get -y install avahi-utils avahi-autoipd avahi-dnsconfd
  423. decarray=( 1 2 3 4 5 6 7 8 9 0 )
  424. PEER_ID=${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}
  425. sed -i "s|#host-name=.*|host-name=P$PEER_ID|g" $rootdir/etc/avahi/avahi-daemon.conf
  426. if [ ! -d $rootdir/etc/avahi/services ]; then
  427. mkdir -p $rootdir/etc/avahi/services
  428. fi
  429. # remove an avahi service which isn't used
  430. if [ -f $rootdir/etc/avahi/services/udisks.service ]; then
  431. rm $rootdir/etc/avahi/services/udisks.service
  432. fi
  433. # Add an ssh service
  434. echo '<?xml version="1.0" standalone="no"?><!--*-nxml-*-->' > $rootdir/etc/avahi/services/ssh.service
  435. echo '<!DOCTYPE service-group SYSTEM "avahi-service.dtd">' >> $rootdir/etc/avahi/services/ssh.service
  436. echo '<service-group>' >> $rootdir/etc/avahi/services/ssh.service
  437. echo ' <name replace-wildcards="yes">%h SSH</name>' >> $rootdir/etc/avahi/services/ssh.service
  438. echo ' <service>' >> $rootdir/etc/avahi/services/ssh.service
  439. echo ' <type>_ssh._tcp</type>' >> $rootdir/etc/avahi/services/ssh.service
  440. echo " <port>$SSH_PORT</port>" >> $rootdir/etc/avahi/services/ssh.service
  441. echo ' </service>' >> $rootdir/etc/avahi/services/ssh.service
  442. echo '</service-group>' >> $rootdir/etc/avahi/services/ssh.service
  443. # keep the daemon running
  444. WATCHDOG_SCRIPT_NAME="keepon"
  445. echo '' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  446. echo '# keep avahi daemon running' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  447. echo 'AVAHI_RUNNING=$(pgrep avahi-daemon > /dev/null && echo Running)' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  448. echo 'if [ ! $AVAHI_RUNNING ]; then' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  449. echo ' systemctl start avahi-daemon' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  450. echo ' echo -n $CURRENT_DATE >> $LOGFILE' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  451. echo ' echo " Avahi daemon restarted" >> $LOGFILE' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  452. echo 'fi' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  453. chmod +x $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  454. }
  455. function mesh_batman {
  456. chroot "$rootdir" apt-get -y install iproute bridge-utils libnetfilter-conntrack3 batctl
  457. chroot "$rootdir" apt-get -y install python-dev libevent-dev ebtables python-pip git
  458. chroot "$rootdir" apt-get -y install wireless-tools rfkill
  459. if ! grep -q "batman_adv" $rootdir/etc/modules; then
  460. echo 'batman_adv' >> $rootdir/etc/modules
  461. fi
  462. BATMAN_SCRIPT=$rootdir/var/lib/batman
  463. if [ -f /usr/local/bin/${PROJECT_NAME}-mesh-batman ]; then
  464. cp /usr/local/bin/${PROJECT_NAME}-mesh-batman $BATMAN_SCRIPT
  465. else
  466. cp /usr/bin/${PROJECT_NAME}-mesh-batman $BATMAN_SCRIPT
  467. fi
  468. BATMAN_DAEMON=$rootdir/etc/systemd/system/batman.service
  469. echo '[Unit]' > $BATMAN_DAEMON
  470. echo 'Description=B.A.T.M.A.N. Advanced' >> $BATMAN_DAEMON
  471. echo 'After=network.target' >> $BATMAN_DAEMON
  472. echo '' >> $BATMAN_DAEMON
  473. echo '[Service]' >> $BATMAN_DAEMON
  474. echo 'RemainAfterExit=yes' >> $BATMAN_DAEMON
  475. echo "ExecStart=/var/lib/batman start" >> $BATMAN_DAEMON
  476. echo "ExecStop=/var/lib/batman stop" >> $BATMAN_DAEMON
  477. echo 'Restart=on-failure' >> $BATMAN_DAEMON
  478. echo 'SuccessExitStatus=3 4' >> $BATMAN_DAEMON
  479. echo 'RestartForceExitStatus=3 4' >> $BATMAN_DAEMON
  480. echo '' >> $BATMAN_DAEMON
  481. echo '# Allow time for the server to start/stop' >> $BATMAN_DAEMON
  482. echo 'TimeoutSec=300' >> $BATMAN_DAEMON
  483. echo '' >> $BATMAN_DAEMON
  484. echo '[Install]' >> $BATMAN_DAEMON
  485. echo 'WantedBy=multi-user.target' >> $BATMAN_DAEMON
  486. chroot "$rootdir" systemctl enable batman
  487. }
  488. function mesh_firewall {
  489. FIREWALL_FILENAME=${rootdir}/etc/systemd/system/meshfirewall.service
  490. MESH_FIREWALL_SCRIPT=${rootdir}/usr/bin/mesh-firewall
  491. echo '#!/bin/bash' > $MESH_FIREWALL_SCRIPT
  492. echo 'iptables -P INPUT ACCEPT' >> $MESH_FIREWALL_SCRIPT
  493. echo 'ip6tables -P INPUT ACCEPT' >> $MESH_FIREWALL_SCRIPT
  494. echo 'iptables -F' >> $MESH_FIREWALL_SCRIPT
  495. echo 'ip6tables -F' >> $MESH_FIREWALL_SCRIPT
  496. echo 'iptables -t nat -F' >> $MESH_FIREWALL_SCRIPT
  497. echo 'ip6tables -t nat -F' >> $MESH_FIREWALL_SCRIPT
  498. echo 'iptables -X' >> $MESH_FIREWALL_SCRIPT
  499. echo 'ip6tables -X' >> $MESH_FIREWALL_SCRIPT
  500. echo 'iptables -P INPUT DROP' >> $MESH_FIREWALL_SCRIPT
  501. echo 'ip6tables -P INPUT DROP' >> $MESH_FIREWALL_SCRIPT
  502. echo 'iptables -A INPUT -i lo -j ACCEPT' >> $MESH_FIREWALL_SCRIPT
  503. echo 'iptables -A INPUT -m conntrack --ctstate ESTABLISHED,RELATED -j ACCEPT' >> $MESH_FIREWALL_SCRIPT
  504. echo '' >> $MESH_FIREWALL_SCRIPT
  505. echo '# Make sure incoming tcp connections are SYN packets' >> $MESH_FIREWALL_SCRIPT
  506. echo 'iptables -A INPUT -p tcp ! --syn -m state --state NEW -j DROP' >> $MESH_FIREWALL_SCRIPT
  507. echo '' >> $MESH_FIREWALL_SCRIPT
  508. echo '# Drop packets with incoming fragments' >> $MESH_FIREWALL_SCRIPT
  509. echo 'iptables -A INPUT -f -j DROP' >> $MESH_FIREWALL_SCRIPT
  510. echo '' >> $MESH_FIREWALL_SCRIPT
  511. echo '# Drop bogons' >> $MESH_FIREWALL_SCRIPT
  512. echo 'iptables -A INPUT -p tcp --tcp-flags ALL ALL -j DROP' >> $MESH_FIREWALL_SCRIPT
  513. echo 'iptables -A INPUT -p tcp --tcp-flags ALL FIN,PSH,URG -j DROP' >> $MESH_FIREWALL_SCRIPT
  514. echo 'iptables -A INPUT -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j DROP' >> $MESH_FIREWALL_SCRIPT
  515. echo '' >> $MESH_FIREWALL_SCRIPT
  516. echo '# Incoming malformed NULL packets:' >> $MESH_FIREWALL_SCRIPT
  517. echo 'iptables -A INPUT -p tcp --tcp-flags ALL NONE -j DROP' >> $MESH_FIREWALL_SCRIPT
  518. echo '' >> $MESH_FIREWALL_SCRIPT
  519. echo "iptables -A INPUT -p tcp --dport $TOX_PORT -j ACCEPT" >> $MESH_FIREWALL_SCRIPT
  520. echo "iptables -A INPUT -i $WIFI_INTERFACE -p udp --dport $ZERONET_PORT -j ACCEPT" >> $MESH_FIREWALL_SCRIPT
  521. echo "iptables -A INPUT -i $WIFI_INTERFACE -p tcp --dport $ZERONET_PORT -j ACCEPT" >> $MESH_FIREWALL_SCRIPT
  522. echo "iptables -A INPUT -i $WIFI_INTERFACE -p udp --dport $TRACKER_PORT -j ACCEPT" >> $MESH_FIREWALL_SCRIPT
  523. echo "iptables -A INPUT -i $WIFI_INTERFACE -p tcp --dport $TRACKER_PORT -j ACCEPT" >> $MESH_FIREWALL_SCRIPT
  524. echo "iptables -A INPUT -i $WIFI_INTERFACE -p udp --dport 1900 -j ACCEPT" >> $MESH_FIREWALL_SCRIPT
  525. chmod +x $MESH_FIREWALL_SCRIPT
  526. echo '[Unit]' > $FIREWALL_FILENAME
  527. echo 'Description=Mesh Firewall' >> $FIREWALL_FILENAME
  528. echo '' >> $FIREWALL_FILENAME
  529. echo '[Service]' >> $FIREWALL_FILENAME
  530. echo 'Type=oneshot' >> $FIREWALL_FILENAME
  531. echo 'ExecStart=/usr/bin/mesh-firewall' >> $FIREWALL_FILENAME
  532. echo 'RemainAfterExit=no' >> $FIREWALL_FILENAME
  533. echo '' >> $FIREWALL_FILENAME
  534. echo 'TimeoutSec=30' >> $FIREWALL_FILENAME
  535. echo '' >> $FIREWALL_FILENAME
  536. echo '[Install]' >> $FIREWALL_FILENAME
  537. echo 'WantedBy=multi-user.target' >> $FIREWALL_FILENAME
  538. chroot "$rootdir" systemctl enable meshfirewall
  539. }
  540. function mesh_tox_node {
  541. # obtain commits from the main file
  542. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  543. TOXCORE_COMMIT_MAIN=$(cat /usr/local/bin/${PROJECT_NAME}-app-tox | grep "TOXCORE_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  544. else
  545. TOXCORE_COMMIT_MAIN=$(cat /usr/bin/${PROJECT_NAME}-app-tox | grep "TOXCORE_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  546. fi
  547. if [ ${#TOXCORE_COMMIT_MAIN} -gt 10 ]; then
  548. TOXCORE_COMMIT=$TOXCORE_COMMIT_MAIN
  549. fi
  550. if [ ! $TOXCORE_COMMIT ]; then
  551. echo $'No Tox commit was specified'
  552. exit 76325
  553. fi
  554. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  555. TOX_PORT_MAIN=$(cat /usr/local/bin/${PROJECT_NAME}-app-tox | grep "TOX_PORT=" | head -n 1 | awk -F '=' '{print $2}')
  556. else
  557. TOX_PORT_MAIN=$(cat /usr/bin/${PROJECT_NAME}-app-tox | grep "TOX_PORT=" | head -n 1 | awk -F '=' '{print $2}')
  558. fi
  559. if [ ${#TOX_PORT_MAIN} -gt 2 ]; then
  560. TOX_PORT=$TOX_PORT_MAIN
  561. fi
  562. if [ ! $TOX_PORT ]; then
  563. echo $'No Tox port was specified'
  564. exit 32856
  565. fi
  566. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  567. TOXCORE_REPO_MAIN=$(cat /usr/local/bin/${PROJECT_NAME}-app-tox | grep "TOXCORE_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  568. else
  569. TOXCORE_REPO_MAIN=$(cat /usr/bin/${PROJECT_NAME}-app-tox | grep "TOXCORE_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  570. fi
  571. if [ ${#TOXCORE_REPO_MAIN} -gt 10 ]; then
  572. TOXCORE_REPO=$TOXCORE_REPO_MAIN
  573. fi
  574. if [ ! $TOXCORE_REPO ]; then
  575. echo $'No Tox repo was specified'
  576. exit 16865
  577. fi
  578. chroot "$rootdir" apt-get -y install build-essential libtool autotools-dev
  579. chroot "$rootdir" apt-get -y install automake checkinstall check git yasm
  580. chroot "$rootdir" apt-get -y install libsodium13 libsodium-dev libcap2-bin
  581. chroot "$rootdir" apt-get -y install libconfig9 libconfig-dev
  582. TEMP_SCRIPT_NAME=fbtmp37272.sh
  583. TEMP_SCRIPT=/tmp/$TEMP_SCRIPT_NAME
  584. echo '#!/bin/bash' > $TEMP_SCRIPT
  585. echo "mkdir -p $INSTALL_DIR" >> $TEMP_SCRIPT
  586. echo "git clone $TOXCORE_REPO $INSTALL_DIR/toxcore" >> $TEMP_SCRIPT
  587. echo "cd $INSTALL_DIR/toxcore" >> $TEMP_SCRIPT
  588. echo "git checkout $TOXCORE_COMMIT -b $TOXCORE_COMMIT" >> $TEMP_SCRIPT
  589. echo 'autoreconf -i' >> $TEMP_SCRIPT
  590. echo './configure --enable-daemon --disable-av' >> $TEMP_SCRIPT
  591. echo 'make' >> $TEMP_SCRIPT
  592. echo 'if [ ! "$?" = "0" ]; then' >> $TEMP_SCRIPT
  593. echo ' exit 1' >> $TEMP_SCRIPT
  594. echo 'fi' >> $TEMP_SCRIPT
  595. echo 'make install' >> $TEMP_SCRIPT
  596. echo 'cp /usr/local/lib/libtoxcore* /usr/lib/' >> $TEMP_SCRIPT
  597. echo "cp $INSTALL_DIR/toxcore/other/bootstrap_daemon/tox-bootstrapd.service /etc/systemd/system/" >> $TEMP_SCRIPT
  598. echo "sed -i 's|ExecStart=.*|ExecStart=/usr/local/bin/tox-bootstrapd --config /etc/tox-bootstrapd.conf|g' /etc/systemd/system/tox-bootstrapd.service" >> $TEMP_SCRIPT
  599. echo 'systemctl enable tox-bootstrapd.service' >> $TEMP_SCRIPT
  600. echo 'exit 0' >> $TEMP_SCRIPT
  601. chmod +x $TEMP_SCRIPT
  602. cp $TEMP_SCRIPT $rootdir/root/
  603. SECONDS=0
  604. chroot "$rootdir" /root/$TEMP_SCRIPT_NAME
  605. if [ ! "$?" = "0" ]; then
  606. duration=$SECONDS
  607. echo $"Toxcore compile failed at $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  608. echo $'Unable to make toxcore'
  609. rm $TEMP_SCRIPT
  610. exit 73835
  611. fi
  612. duration=$SECONDS
  613. echo $"Toxcore compile $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  614. rm $TEMP_SCRIPT
  615. if [ ! -f $rootdir/usr/local/bin/tox-bootstrapd ]; then
  616. echo $"File not found /usr/local/bin/tox-bootstrapd"
  617. exit 37825
  618. fi
  619. chroot "$rootdir" useradd --home-dir /var/lib/tox-bootstrapd --create-home --system --shell /sbin/nologin --comment $"Account to run Tox's DHT bootstrap daemon" --user-group tox-bootstrapd
  620. chroot "$rootdir" chmod 700 /var/lib/tox-bootstrapd
  621. # remove Maildir
  622. if [ -d $rootdir/var/lib/tox-bootstrapd/Maildir ]; then
  623. rm -rf $rootdir/var/lib/tox-bootstrapd/Maildir
  624. fi
  625. # create configuration file
  626. TOX_BOOTSTRAP_CONFIG=$rootdir/etc/tox-bootstrapd.conf
  627. echo "port = $TOX_PORT" > $TOX_BOOTSTRAP_CONFIG
  628. echo 'keys_file_path = "/var/lib/tox-bootstrapd/keys"' >> $TOX_BOOTSTRAP_CONFIG
  629. echo 'pid_file_path = "/var/run/tox-bootstrapd/tox-bootstrapd.pid"' >> $TOX_BOOTSTRAP_CONFIG
  630. echo 'enable_ipv6 = true' >> $TOX_BOOTSTRAP_CONFIG
  631. echo 'enable_ipv4_fallback = true' >> $TOX_BOOTSTRAP_CONFIG
  632. echo 'enable_lan_discovery = true' >> $TOX_BOOTSTRAP_CONFIG
  633. echo 'enable_tcp_relay = true' >> $TOX_BOOTSTRAP_CONFIG
  634. echo "tcp_relay_ports = [443, 3389, $TOX_PORT]" >> $TOX_BOOTSTRAP_CONFIG
  635. echo 'enable_motd = true' >> $TOX_BOOTSTRAP_CONFIG
  636. echo 'motd = "tox-bootstrapd"' >> $TOX_BOOTSTRAP_CONFIG
  637. if [ $TOX_NODES ]; then
  638. echo 'bootstrap_nodes = (' >> $TOX_BOOTSTRAP_CONFIG
  639. toxcount=0
  640. while [ "x${TOX_NODES[toxcount]}" != "x" ]
  641. do
  642. toxval_ipv4=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $1}')
  643. toxval_ipv6=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $2}')
  644. toxval_port=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $3}')
  645. toxval_pubkey=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $4}')
  646. toxval_maintainer=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $5}')
  647. echo "{ // $toxval_maintainer" >> $TOX_BOOTSTRAP_CONFIG
  648. if [[ $toxval_ipv6 != 'NONE' ]]; then
  649. echo " address = \"$toxval_ipv6\"" >> $TOX_BOOTSTRAP_CONFIG
  650. else
  651. echo " address = \"$toxval_ipv4\"" >> $TOX_BOOTSTRAP_CONFIG
  652. fi
  653. echo " port = $toxval_port" >> $TOX_BOOTSTRAP_CONFIG
  654. echo " public_key = \"$toxval_pubkey\"" >> $TOX_BOOTSTRAP_CONFIG
  655. toxcount=$(( $toxcount + 1 ))
  656. if [ "x${TOX_NODES[toxcount]}" != "x" ]; then
  657. echo "}," >> $TOX_BOOTSTRAP_CONFIG
  658. else
  659. echo "}" >> $TOX_BOOTSTRAP_CONFIG
  660. fi
  661. done
  662. echo ')' >> $TOX_BOOTSTRAP_CONFIG
  663. fi
  664. }
  665. function mesh_tox_avahi {
  666. if [ ! -d $rootdir/etc/avahi ]; then
  667. echo $'tox_avahi: avahi is not installed'
  668. exit 87359
  669. fi
  670. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  671. TOXID_REPO_MAIN=$(cat /usr/local/bin/${PROJECT_NAME}-app-tox | grep "TOXID_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  672. else
  673. TOXID_REPO_MAIN=$(cat /usr/bin/${PROJECT_NAME}-app-tox | grep "TOXID_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  674. fi
  675. if [ ${#TOXID_REPO_MAIN} -gt 5 ]; then
  676. TOXID_REPO=$TOXID_REPO_MAIN
  677. fi
  678. if [ ! $TOXID_REPO ]; then
  679. echo $'No ToxID repo was specified'
  680. exit 78252
  681. fi
  682. TEMP_SCRIPT_NAME=fbtmp5328252.sh
  683. TEMP_SCRIPT=/tmp/$TEMP_SCRIPT_NAME
  684. echo '#!/bin/bash' > $TEMP_SCRIPT
  685. echo "mkdir -p $INSTALL_DIR" >> $TEMP_SCRIPT
  686. echo "git clone $TOXID_REPO $INSTALL_DIR/toxid" >> $TEMP_SCRIPT
  687. echo "if [ ! -d $INSTALL_DIR/toxid ]; then" >> $TEMP_SCRIPT
  688. echo ' exit 1' >> $TEMP_SCRIPT
  689. echo 'fi' >> $TEMP_SCRIPT
  690. echo "cd $INSTALL_DIR/toxid" >> $TEMP_SCRIPT
  691. echo "make" >> $TEMP_SCRIPT
  692. echo 'if [ ! "$?" = "0" ]; then' >> $TEMP_SCRIPT
  693. echo ' exit 2' >> $TEMP_SCRIPT
  694. echo 'fi' >> $TEMP_SCRIPT
  695. echo 'make install' >> $TEMP_SCRIPT
  696. echo 'if [ ! -f /usr/local/bin/toxavahi ]; then' >> $TEMP_SCRIPT
  697. echo ' exit 3' >> $TEMP_SCRIPT
  698. echo 'fi' >> $TEMP_SCRIPT
  699. echo 'toxavahi' >> $TEMP_SCRIPT
  700. echo 'echo "* * * * * root /usr/local/bin/toxavahi > /dev/null" >> /etc/crontab' >> $TEMP_SCRIPT
  701. echo 'systemctl restart avahi-daemon' >> $TEMP_SCRIPT
  702. echo 'exit 0' >> $TEMP_SCRIPT
  703. chmod +x $TEMP_SCRIPT
  704. cp $TEMP_SCRIPT $rootdir/root/
  705. chroot "$rootdir" /root/$TEMP_SCRIPT_NAME
  706. if [ ! "$?" = "0" ]; then
  707. echo $"Unable to install toxid, returned $?"
  708. rm $TEMP_SCRIPT
  709. exit 62835
  710. fi
  711. rm $TEMP_SCRIPT
  712. }
  713. function mesh_tox_client {
  714. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  715. TOXIC_FILE=$(cat /usr/local/bin/${PROJECT_NAME}-app-tox | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
  716. else
  717. TOXIC_FILE=$(cat /usr/bin/${PROJECT_NAME}-app-tox | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
  718. fi
  719. # obtain commits from the main file
  720. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  721. TOXIC_COMMIT_MAIN=$(cat /usr/local/bin/${PROJECT_NAME}-app-tox | grep "TOXIC_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  722. else
  723. TOXIC_COMMIT_MAIN=$(cat /usr/bin/${PROJECT_NAME}-app-tox | grep "TOXIC_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  724. fi
  725. if [ ${#TOXIC_COMMIT_MAIN} -gt 10 ]; then
  726. TOXIC_COMMIT=$TOXIC_COMMIT_MAIN
  727. fi
  728. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  729. TOXIC_REPO_MAIN=$(cat /usr/local/bin/${PROJECT_NAME}-app-tox | grep "TOXIC_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  730. else
  731. TOXIC_REPO_MAIN=$(cat /usr/bin/${PROJECT_NAME}-app-tox | grep "TOXIC_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  732. fi
  733. if [ ${#TOXIC_REPO_MAIN} -gt 5 ]; then
  734. TOXIC_REPO=$TOXIC_REPO_MAIN
  735. fi
  736. chroot "$rootdir" apt-get -y install libncursesw5-dev libconfig-dev libqrencode-dev
  737. chroot "$rootdir" apt-get -y install libcurl4-openssl-dev libvpx-dev libopenal-dev
  738. TEMP_SCRIPT_NAME=fbtmp728353.sh
  739. TEMP_SCRIPT=/tmp/$TEMP_SCRIPT_NAME
  740. echo '#!/bin/bash' > $TEMP_SCRIPT
  741. echo "mkdir -p $INSTALL_DIR" >> $TEMP_SCRIPT
  742. echo "git clone $TOXIC_REPO $INSTALL_DIR/toxic" >> $TEMP_SCRIPT
  743. echo "cd $INSTALL_DIR/toxic" >> $TEMP_SCRIPT
  744. echo "git checkout $TOXIC_COMMIT -b $TOXIC_COMMIT" >> $TEMP_SCRIPT
  745. echo 'make' >> $TEMP_SCRIPT
  746. echo 'if [ ! "$?" = "0" ]; then' >> $TEMP_SCRIPT
  747. echo ' exit 1' >> $TEMP_SCRIPT
  748. echo 'fi' >> $TEMP_SCRIPT
  749. echo 'make install' >> $TEMP_SCRIPT
  750. echo 'exit 0' >> $TEMP_SCRIPT
  751. chmod +x $TEMP_SCRIPT
  752. cp $TEMP_SCRIPT $rootdir/root/
  753. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  754. TOXIC_FILE=$(cat /usr/local/bin/${PROJECT_NAME} | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
  755. else
  756. TOXIC_FILE=$(cat /usr/bin/${PROJECT_NAME} | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
  757. fi
  758. SECONDS=0
  759. chroot "$rootdir" /root/$TEMP_SCRIPT_NAME
  760. if [ ! "$?" = "0" ]; then
  761. duration=$SECONDS
  762. echo $"Toxic client compile failed at $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  763. echo $'Unable to make tox client'
  764. rm $TEMP_SCRIPT
  765. exit 74872
  766. fi
  767. rm $TEMP_SCRIPT
  768. if [ ! -f $rootdir$TOXIC_FILE ]; then
  769. echo $"Tox client was not installed to $TOXIC_FILE"
  770. exit 63278
  771. fi
  772. duration=$SECONDS
  773. echo $"Toxic client compile $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  774. }
  775. function mesh_zeronet {
  776. # obtain commits from the main file
  777. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  778. ZERONET_COMMIT_MAIN=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  779. else
  780. ZERONET_COMMIT_MAIN=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  781. fi
  782. if [ ${#ZERONET_COMMIT_MAIN} -gt 10 ]; then
  783. ZERONET_COMMIT=$ZERONET_COMMIT_MAIN
  784. fi
  785. if [ ! $ZERONET_COMMIT ]; then
  786. echo $'No Tox commit was specified'
  787. exit 37046
  788. fi
  789. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  790. ZERONET_REPO_MAIN=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  791. else
  792. ZERONET_REPO_MAIN=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  793. fi
  794. if [ ${#ZERONET_REPO_MAIN} -gt 5 ]; then
  795. ZERONET_REPO=$ZERONET_REPO_MAIN
  796. fi
  797. if [ ! $ZERONET_REPO ]; then
  798. echo $'No Tox commit was specified'
  799. exit 37046
  800. fi
  801. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  802. ZERONET_PORT_MAIN=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_PORT=" | head -n 1 | awk -F '=' '{print $2}')
  803. else
  804. ZERONET_PORT_MAIN=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_PORT=" | head -n 1 | awk -F '=' '{print $2}')
  805. fi
  806. if [ ${#ZERONET_PORT_MAIN} -gt 1 ]; then
  807. ZERONET_PORT=$ZERONET_PORT_MAIN
  808. fi
  809. if [ ! $ZERONET_PORT ]; then
  810. echo $'No zeronet port was specified'
  811. exit 67433
  812. fi
  813. chroot "$rootdir" apt-get -y install python python-msgpack python-gevent
  814. chroot "$rootdir" apt-get -y install python-pip bittornado
  815. chroot "$rootdir" pip install msgpack-python --upgrade
  816. chroot "$rootdir" useradd -d $MESH_INSTALL_DIR/zeronet/ -s /bin/false zeronet
  817. git clone $ZERONET_REPO $rootdir$MESH_INSTALL_DIR/zeronet
  818. if [ ! -d $rootdir$MESH_INSTALL_DIR/zeronet ]; then
  819. echo 'WARNING: Unable to clone zeronet'
  820. return
  821. fi
  822. cd $rootdir$MESH_INSTALL_DIR/zeronet
  823. git checkout $ZERONET_COMMIT -b $ZERONET_COMMIT
  824. if ! grep -q "ZeroNet commit" $COMPLETION_FILE; then
  825. echo "ZeroNet commit:$ZERONET_COMMIT" >> $rootdir$COMPLETION_FILE
  826. else
  827. sed -i "s/ZeroNet commit.*/ZeroNet commit:$ZERONET_COMMIT/g" $COMPLETION_FILE
  828. fi
  829. chroot "$rootdir" chown -R zeronet:zeronet $MESH_INSTALL_DIR/zeronet
  830. # Hack to ensure that the file access port is opened
  831. # This is because zeronet normally relies on an internet site
  832. # to do this, but on a purely local mesh the internet isn't available
  833. sed -i 's|fileserver_port = 0|fileserver_port = config.fileserver_port\n sys.modules["main"].file_server.port_opened = True|g' $rootdir$MESH_INSTALL_DIR/zeronet/src/Site/Site.py
  834. ZERONET_DAEMON=$rootdir/etc/systemd/system/zeronet.service
  835. echo '[Unit]' > $ZERONET_DAEMON
  836. echo 'Description=Zeronet Server' >> $ZERONET_DAEMON
  837. echo 'After=syslog.target' >> $ZERONET_DAEMON
  838. echo 'After=network.target' >> $ZERONET_DAEMON
  839. echo '[Service]' >> $ZERONET_DAEMON
  840. echo 'Type=simple' >> $ZERONET_DAEMON
  841. echo 'User=zeronet' >> $ZERONET_DAEMON
  842. echo 'Group=zeronet' >> $ZERONET_DAEMON
  843. echo "WorkingDirectory=$MESH_INSTALL_DIR/zeronet" >> $ZERONET_DAEMON
  844. echo "ExecStart=/usr/bin/python zeronet.py --ip_external replace.local --trackers_file $MESH_INSTALL_DIR/zeronet/bootstrap" >> $ZERONET_DAEMON
  845. echo '' >> $ZERONET_DAEMON
  846. echo 'TimeoutSec=300' >> $ZERONET_DAEMON
  847. echo '' >> $ZERONET_DAEMON
  848. echo '[Install]' >> $ZERONET_DAEMON
  849. echo 'WantedBy=multi-user.target' >> $ZERONET_DAEMON
  850. TRACKER_DAEMON=$rootdir/etc/systemd/system/tracker.service
  851. echo '[Unit]' > $TRACKER_DAEMON
  852. echo 'Description=Torrent Tracker' >> $TRACKER_DAEMON
  853. echo 'After=syslog.target' >> $TRACKER_DAEMON
  854. echo 'After=network.target' >> $TRACKER_DAEMON
  855. echo '[Service]' >> $TRACKER_DAEMON
  856. echo 'Type=simple' >> $TRACKER_DAEMON
  857. echo 'User=tracker' >> $TRACKER_DAEMON
  858. echo 'Group=tracker' >> $TRACKER_DAEMON
  859. echo "WorkingDirectory=$MESH_INSTALL_DIR/tracker" >> $TRACKER_DAEMON
  860. echo "ExecStart=/usr/bin/bttrack --port $TRACKER_PORT --dfile $MESH_INSTALL_DIR/tracker/dstate --logfile $MESH_INSTALL_DIR/tracker/tracker.log --nat_check 0 --scrape_allowed full --ipv6_enabled 0" >> $TRACKER_DAEMON
  861. echo '' >> $TRACKER_DAEMON
  862. echo 'TimeoutSec=300' >> $TRACKER_DAEMON
  863. echo '' >> $TRACKER_DAEMON
  864. echo '[Install]' >> $TRACKER_DAEMON
  865. echo 'WantedBy=multi-user.target' >> $TRACKER_DAEMON
  866. chroot "$rootdir" useradd -d $MESH_INSTALL_DIR/tracker/ -s /bin/false tracker
  867. if [ ! -d $rootdir$MESH_INSTALL_DIR/tracker ]; then
  868. mkdir $rootdir$MESH_INSTALL_DIR/tracker
  869. fi
  870. chroot "$rootdir" chown -R tracker:tracker $MESH_INSTALL_DIR/tracker
  871. # publish regularly
  872. echo "* * * * * root zeronetavahi > /dev/null" >> $rootdir/etc/crontab
  873. chroot "$rootdir" systemctl enable tracker.service
  874. chroot "$rootdir" systemctl enable zeronet.service
  875. }
  876. function mesh_zeronet_blog {
  877. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  878. ZERONET_BLOG_REPO=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_BLOG_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  879. ZERONET_BLOG_COMMIT=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_BLOG_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  880. else
  881. ZERONET_BLOG_REPO=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_BLOG_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  882. ZERONET_BLOG_COMMIT=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_BLOG_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  883. fi
  884. git clone $ZERONET_BLOG_REPO $rootdir$MESH_INSTALL_DIR/zeronet/ZeroBlog
  885. if [ ! -d $rootdir$MESH_INSTALL_DIR/zeronet/ZeroBlog ]; then
  886. echo $'ZeroBlog repo could not be cloned'
  887. exit 6739
  888. fi
  889. cd $rootdir$MESH_INSTALL_DIR/zeronet/ZeroBlog
  890. git checkout $ZERONET_BLOG_COMMIT -b $ZERONET_BLOG_COMMIT
  891. chroot "$rootdir" chown -R zeronet:zeronet $MESH_INSTALL_DIR/zeronet
  892. }
  893. function mesh_zeronet_mail {
  894. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  895. ZERONET_MAIL_REPO=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_MAIL_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  896. ZERONET_MAIL_COMMIT=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_MAIL_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  897. else
  898. ZERONET_MAIL_REPO=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_MAIL_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  899. ZERONET_MAIL_COMMIT=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_MAIL_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  900. fi
  901. git clone $ZERONET_MAIL_REPO $rootdir$MESH_INSTALL_DIR/zeronet/ZeroMail
  902. if [ ! -d $rootdir$MESH_INSTALL_DIR/zeronet/ZeroMail ]; then
  903. echo $'ZeroMail repo could not be cloned'
  904. exit 78493
  905. fi
  906. cd $rootdir$MESH_INSTALL_DIR/zeronet/ZeroMail
  907. git checkout $ZERONET_MAIL_COMMIT -b $ZERONET_MAIL_COMMIT
  908. chroot "$rootdir" chown -R zeronet:zeronet $MESH_INSTALL_DIR/zeronet
  909. }
  910. function mesh_zeronet_forum {
  911. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  912. ZERONET_FORUM_REPO=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_FORUM_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  913. ZERONET_FORUM_COMMIT=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_FORUM_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  914. else
  915. ZERONET_FORUM_REPO=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_FORUM_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  916. ZERONET_FORUM_COMMIT=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_FORUM_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  917. fi
  918. git clone $ZERONET_FORUM_REPO $rootdir$MESH_INSTALL_DIR/zeronet/ZeroTalk
  919. if [ ! -d $rootdir$MESH_INSTALL_DIR/zeronet/ZeroTalk ]; then
  920. echo $'ZeroTalk repo could not be cloned'
  921. exit 78252
  922. fi
  923. cd $rootdir$MESH_INSTALL_DIR/zeronet/ZeroTalk
  924. git checkout $ZERONET_FORUM_COMMIT -b $ZERONET_FORUM_COMMIT
  925. chroot "$rootdir" chown -R zeronet:zeronet $MESH_INSTALL_DIR/zeronet
  926. }
  927. function mesh_zeronet_id {
  928. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  929. ZERONET_ID_REPO=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_ID_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  930. ZERONET_ID_COMMIT=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_ID_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  931. else
  932. ZERONET_ID_REPO=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_ID_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  933. ZERONET_ID_COMMIT=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_ID_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  934. fi
  935. git clone $ZERONET_ID_REPO $rootdir$MESH_INSTALL_DIR/zeronet/ZeroID
  936. if [ ! -d $rootdir$MESH_INSTALL_DIR/zeronet/ZeroID ]; then
  937. echo $'ZeroID repo could not be cloned'
  938. exit 37936
  939. fi
  940. cd $rootdir$MESH_INSTALL_DIR/zeronet/ZeroID
  941. git checkout $ZERONET_ID_COMMIT -b $ZERONET_ID_COMMIT
  942. chroot "$rootdir" chown -R zeronet:zeronet $MESH_INSTALL_DIR/zeronet
  943. }
  944. function mesh_web_server {
  945. if [ -d /etc/apache2 ]; then
  946. chroot "$rootdir" apt-get -y remove --purge apache2
  947. chroot "$rootdir" rm -rf /etc/apache2
  948. fi
  949. chroot "$rootdir" apt-get -y install nginx
  950. if [ ! -d $rootdir/etc/nginx ]; then
  951. echo $'Unable to install web server'
  952. exit 346825
  953. fi
  954. }
  955. initialise_mesh() {
  956. if [[ $VARIANT != "mesh" && $VARIANT != "meshclient" && $VARIANT != "meshusb" ]]; then
  957. return
  958. fi
  959. if [[ $DEBIAN_INSTALL_ONLY != "no" ]]; then
  960. return
  961. fi
  962. if [[ $INSECURE == $'yes' ]]; then
  963. echo '*********************************************************'
  964. echo $'WARNING: non-free wifi drivers are being installed.'
  965. echo $' This may compromise the security of your system.'
  966. echo '*********************************************************'
  967. # enable non-free repo
  968. if ! grep -q "non-free" $rootdir/etc/apt/sources.list; then
  969. chroot "$rootdir" sed -i "s| main| main non-free|g" /etc/apt/sources.list
  970. chroot "$rootdir" apt-get update
  971. fi
  972. # install proprietary wifi drivers
  973. # see https://wiki.debian.org/iwlwifi
  974. chroot "$rootdir" apt-get -y install firmware-iwlwifi
  975. fi
  976. mesh_firewall
  977. mesh_avahi
  978. mesh_batman
  979. mesh_tox_node
  980. mesh_tox_avahi
  981. mesh_tox_client
  982. mesh_web_server
  983. mesh_zeronet
  984. mesh_zeronet_blog
  985. mesh_zeronet_mail
  986. mesh_zeronet_forum
  987. MESH_SERVICE='mesh-setup.service'
  988. MESH_SETUP_DAEMON=$rootdir/etc/systemd/system/$MESH_SERVICE
  989. echo '[Unit]' > $MESH_SETUP_DAEMON
  990. echo 'Description=Initial mesh router configuration' >> $MESH_SETUP_DAEMON
  991. echo 'After=syslog.target' >> $MESH_SETUP_DAEMON
  992. echo 'After=network.target' >> $MESH_SETUP_DAEMON
  993. echo '[Service]' >> $MESH_SETUP_DAEMON
  994. echo 'Type=simple' >> $MESH_SETUP_DAEMON
  995. echo 'User=root' >> $MESH_SETUP_DAEMON
  996. echo 'Group=root' >> $MESH_SETUP_DAEMON
  997. echo 'WorkingDirectory=/root' >> $MESH_SETUP_DAEMON
  998. echo "ExecStart=/usr/local/bin/${PROJECT_NAME}-image-mesh > /var/log/mesh-setup.log" >> $MESH_SETUP_DAEMON
  999. echo '' >> $MESH_SETUP_DAEMON
  1000. echo 'TimeoutSec=99999' >> $MESH_SETUP_DAEMON
  1001. echo '' >> $MESH_SETUP_DAEMON
  1002. echo '[Install]' >> $MESH_SETUP_DAEMON
  1003. echo 'WantedBy=multi-user.target' >> $MESH_SETUP_DAEMON
  1004. chroot "$rootdir" systemctl enable $MESH_SERVICE
  1005. }
  1006. # User interface for USB drive installs ######################################
  1007. function enable_tox_repo {
  1008. echo 'deb http://download.opensuse.org/repositories/home:/antonbatenev:/tox/Debian_8.0/ /' > $rootdir/etc/apt/sources.list.d/tox.list
  1009. chroot "$rootdir" wget -q http://download.opensuse.org/repositories/home:antonbatenev:tox/Debian_8.0/Release.key -O- | apt-key add -
  1010. chroot "$rootdir" apt-get update
  1011. echo "Tox Repository Installed."
  1012. }
  1013. function install_syncthing {
  1014. if [[ $SYSTEM_TYPE == "$VARIANT_WRITER" || $SYSTEM_TYPE == "$VARIANT_MAILBOX" || $SYSTEM_TYPE == "$VARIANT_CHAT" || $SYSTEM_TYPE == "$VARIANT_SOCIAL" || $SYSTEM_TYPE == "$VARIANT_MEDIA" || $SYSTEM_TYPE == "$VARIANT_DEVELOPER" ]]; then
  1015. return
  1016. fi
  1017. chroot "$rootdir" wget -q https://syncthing.net/release-key.txt -O- | apt-key add -
  1018. echo "deb http://apt.syncthing.net/ syncthing release" | tee $rootdir/etc/apt/sources.list.d/syncthing.list
  1019. chroot "$rootdir" apt-get update
  1020. chroot "$rootdir" apt-get -y --force-yes install syncthing
  1021. # This probably does need to run as root so that it can access the Sync directories
  1022. # in each user's home directory
  1023. chroot "$rootdir" echo '[Unit]' > /etc/systemd/system/syncthing.service
  1024. chroot "$rootdir" echo 'Description=Syncthing - Open Source Continuous File Synchronization' >> /etc/systemd/system/syncthing.service
  1025. chroot "$rootdir" echo 'Documentation=man:syncthing(1)' >> /etc/systemd/system/syncthing.service
  1026. chroot "$rootdir" echo 'After=network.target' >> /etc/systemd/system/syncthing.service
  1027. chroot "$rootdir" echo 'Wants=syncthing-inotify@.service' >> /etc/systemd/system/syncthing.service
  1028. chroot "$rootdir" echo '' >> /etc/systemd/system/syncthing.service
  1029. chroot "$rootdir" echo '[Service]' >> /etc/systemd/system/syncthing.service
  1030. chroot "$rootdir" echo 'User=root' >> /etc/systemd/system/syncthing.service
  1031. chroot "$rootdir" echo "Environment='all_proxy=socks5://localhost:9050'" >> /etc/systemd/system/syncthing.service
  1032. chroot "$rootdir" echo 'ExecStart=/usr/bin/syncthing -no-browser -no-restart -logflags=0' >> /etc/systemd/system/syncthing.service
  1033. chroot "$rootdir" echo 'Restart=on-failure' >> /etc/systemd/system/syncthing.service
  1034. chroot "$rootdir" echo 'SuccessExitStatus=3 4' >> /etc/systemd/system/syncthing.service
  1035. chroot "$rootdir" echo 'RestartForceExitStatus=3 4' >> /etc/systemd/system/syncthing.service
  1036. chroot "$rootdir" echo '' >> /etc/systemd/system/syncthing.service
  1037. chroot "$rootdir" echo '[Install]' >> /etc/systemd/system/syncthing.service
  1038. chroot "$rootdir" echo 'WantedBy=multi-user.target' >> /etc/systemd/system/syncthing.service
  1039. chroot "$rootdir" systemctl enable syncthing
  1040. chroot "$rootdir" systemctl daemon-reload
  1041. if ! grep -q "syncthing" $rootdir/etc/crontab; then
  1042. chroot "$rootdir" echo "*/1 * * * * root /usr/local/bin/freedombone-syncthing > /dev/null" >> /etc/crontab
  1043. chroot "$rootdir" systemctl restart cron
  1044. fi
  1045. echo 'install_syncthing'
  1046. }
  1047. function mesh_client_startup_applications {
  1048. if [ ! -d $rootdir/home/$MY_USERNAME/Desktop ]; then
  1049. mkdir -p $rootdir/home/$MY_USERNAME/Desktop
  1050. fi
  1051. if [ ! -d $rootdir/home/$MY_USERNAME/.config/autostart ]; then
  1052. mkdir -p $rootdir/home/$MY_USERNAME/.config/autostart
  1053. fi
  1054. echo '[Desktop Entry]' > $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  1055. echo 'Name=Tox Chat' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  1056. echo 'Type=Application' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  1057. echo 'Comment=Chat, VoIP, Video' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  1058. echo 'TryExec=qtox' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  1059. echo 'Exec=qtox' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  1060. echo 'Icon=qtox' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  1061. echo 'StartupNotify=true' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  1062. cp $rootdir/home/$MY_USERNAME/Desktop/tox.desktop $rootdir/home/$MY_USERNAME/.config/autostart/tox.desktop
  1063. chroot "$rootdir" chown -R $MY_USERNAME:$MY_USERNAME /home/$MY_USERNAME/.config
  1064. }
  1065. function mesh_desktop_icons {
  1066. if [ ! -d $rootdir/home/$MY_USERNAME/Desktop ]; then
  1067. mkdir -p $rootdir/home/$MY_USERNAME/Desktop
  1068. fi
  1069. # Terminal
  1070. echo '[Desktop Entry]' > $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  1071. echo 'Name=MATE Terminal' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  1072. echo 'Type=Application' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  1073. echo 'Comment=Use the command line' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  1074. echo 'TryExec=mate-terminal' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  1075. echo 'Exec=mate-terminal' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  1076. echo 'Icon=terminal' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  1077. echo 'StartupNotify=true' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  1078. # browse
  1079. echo '[Desktop Entry]' > $rootdir/home/$MY_USERNAME/Desktop/mesh.desktop
  1080. echo 'Name=Mesh' >> $rootdir/home/$MY_USERNAME/Desktop/mesh.desktop
  1081. echo 'Type=Application' >> $rootdir/home/$MY_USERNAME/Desktop/mesh.desktop
  1082. echo 'Comment=Browse the mesh' >> $rootdir/home/$MY_USERNAME/Desktop/mesh.desktop
  1083. echo 'TryExec=meshweb' >> $rootdir/home/$MY_USERNAME/Desktop/mesh.desktop
  1084. echo 'Exec=meshweb' >> $rootdir/home/$MY_USERNAME/Desktop/mesh.desktop
  1085. echo "Icon=$BROWSER" >> $rootdir/home/$MY_USERNAME/Desktop/mesh.desktop
  1086. echo 'StartupNotify=true' >> $rootdir/home/$MY_USERNAME/Desktop/mesh.desktop
  1087. chroot "$rootdir" chown -R $MY_USERNAME:$MY_USERNAME /home/$MY_USERNAME/Desktop
  1088. }
  1089. function configure_user_interface {
  1090. if [[ $VARIANT != "meshclient" && $VARIANT != "meshusb" && $VARIANT != "usb" ]]; then
  1091. return
  1092. fi
  1093. # desktop
  1094. chroot "$rootdir" apt-get -y install mate-desktop-environment
  1095. # tool to change desktop settings from command line
  1096. chroot "$rootdir" apt-get -y install dconf-cli dconf-gsettings-backend dbus dbus-x11
  1097. if [[ $VARIANT != "usb" ]]; then
  1098. # log in automatically
  1099. chroot "$rootdir" apt-get -y install nodm xinit
  1100. echo 'NODM_ENABLED=true' > /etc/default/nodm
  1101. echo "NODM_USER=$MY_USERNAME" >> /etc/default/nodm
  1102. chroot "$rootdir" mkdir /etc/systemd/system/getty@tty1.service.d
  1103. echo '[Service]' > $rootdir/etc/systemd/system/getty@tty1.service.d/override.conf
  1104. echo 'ExecStart=' >> $rootdir/etc/systemd/system/getty@tty1.service.d/override.conf
  1105. echo 'ExecStart=-/sbin/agetty --autologin fbone --noclear %I $TERM' >> $rootdir/etc/systemd/system/getty@tty1.service.d/override.conf
  1106. echo '[[ -z $DISPLAY && $XDG_VTNR -eq 1 ]] && exec startx' >> $rootdir/home/$MY_USERNAME/.profile
  1107. chroot "$rootdir" systemctl set-default multi-user.target
  1108. mesh_client_startup_applications
  1109. mesh_desktop_icons
  1110. # change the desktop background
  1111. if [ $MESH_DESKTOP_BACKGROUND_IMAGE ]; then
  1112. if [ -f $MESH_DESKTOP_BACKGROUND_IMAGE ]; then
  1113. if [ -d $rootdir/usr/share/images/desktop-base ]; then
  1114. cp $MESH_DESKTOP_BACKGROUND_IMAGE $rootdir/usr/share/images/desktop-base/${PROJECT_NAME}_mesh_background.png
  1115. chroot "$rootdir" rm /usr/share/images/desktop-base/desktop-background
  1116. chroot "$rootdir" ln -s /usr/share/images/desktop-base/${PROJECT_NAME}_mesh_background.png /usr/share/images/desktop-base/desktop-background
  1117. fi
  1118. fi
  1119. fi
  1120. else
  1121. chroot "$rootdir" apt-get -y install lightdm
  1122. fi
  1123. # browser
  1124. chroot "$rootdir" apt-get -y install $BROWSER
  1125. # NOTE: The Tox repo only supports a limited range of architectures
  1126. if [[ $ARCHITECTURE == 'amd64' || $ARCHITECTURE == 'i386' ]]; then
  1127. # Tox user interface
  1128. enable_tox_repo
  1129. # TODO: this may not work on all architectures
  1130. chroot "$rootdir" apt-get -y --force-yes install qtox
  1131. fi
  1132. # Syncthing
  1133. install_syncthing
  1134. if [[ $VARIANT == "usb" ]]; then
  1135. # tor
  1136. chroot "$rootdir" apt-get -y install tor
  1137. # xmpp client
  1138. chroot "$rootdir" echo "deb ftp://ftp.gajim.org/debian unstable main" > /etc/apt/sources.list.d/gajim.list
  1139. chroot "$rootdir" apt-get update
  1140. chroot "$rootdir" apt-get -y install gajim-dev-keyring
  1141. chroot "$rootdir" apt-get -y install git python-dev python-pip gajim-nightly
  1142. chroot "$rootdir" mkdir /home/$GENERIC_IMAGE_USERNAME/.local/share/gajim/plugins -p
  1143. chroot "$rootdir" git clone https://github.com/omemo/gajim-omemo /home/$GENERIC_IMAGE_USERNAME/.local/share/gajim/plugins/gajim-omemo
  1144. chroot "$rootdir" pip install protobuf==2.6.1, python-axolotl==0.1.35
  1145. chroot "$rootdir" chown -R $GENERIC_IMAGE_USERNAME:$GENERIC_IMAGE_USERNAME /home/$GENERIC_IMAGE_USERNAME/.local
  1146. # IRC client
  1147. chroot "$rootdir" apt-get -y install hexchat profanity
  1148. # zeronet
  1149. # TODO
  1150. fi
  1151. }
  1152. ##############################################################################
  1153. # Set to true/false to control if eatmydata is used during build
  1154. use_eatmydata=true
  1155. rootdir="$1"
  1156. fmdir="$(pwd)"
  1157. image="$fmdir"/"$2"
  1158. cd "$rootdir"
  1159. echo info: building $MACHINE for $ARCHITECTURE
  1160. export DEBIAN_FRONTEND=noninteractive DEBCONF_NONINTERACTIVE_SEEN=true
  1161. export LC_ALL=C LANGUAGE=C LANG=C
  1162. # Override libpam-tmpdir setting during build, as the directories
  1163. # are not created yet.
  1164. export TMP=/tmp/ TMPDIR=/tmp/
  1165. username=$MY_USERNAME
  1166. echo $"warning: creating initial user $username with well known password!"
  1167. password=$MY_PASSWORD
  1168. chroot "$rootdir" adduser --gecos $username --disabled-password $username
  1169. echo $username:$password | chroot $rootdir /usr/sbin/chpasswd
  1170. chroot "$rootdir" adduser $username sudo
  1171. case "$MACHINE" in
  1172. virtualbox)
  1173. # hide irrelevant console keyboard messages.
  1174. echo "echo \"4 4 1 7\" > /proc/sys/kernel/printk" \
  1175. >> /etc/init.d/rc.local
  1176. ;;
  1177. qemu)
  1178. # hide irrelevant console keyboard messages.
  1179. echo "echo \"4 4 1 7\" > /proc/sys/kernel/printk" \
  1180. >> /etc/init.d/rc.local
  1181. ;;
  1182. esac
  1183. set_apt_sources $BUILD_MIRROR
  1184. chroot "$rootdir" apt-get clean
  1185. chroot "$rootdir" rm -rf /var/lib/apt/lists/*
  1186. chroot "$rootdir" apt-get clean
  1187. chroot "$rootdir" apt-get update
  1188. cat > $rootdir/usr/sbin/policy-rc.d <<EOF
  1189. #!/bin/sh
  1190. exit 101
  1191. EOF
  1192. chmod a+rx $rootdir/usr/sbin/policy-rc.d
  1193. if $use_eatmydata ; then
  1194. enable_eatmydata_override
  1195. fi
  1196. if [ -n "$CUSTOM_SETUP" ]; then
  1197. cp "$CUSTOM_SETUP" "$rootdir"/tmp
  1198. chroot "$rootdir" apt-get install -y gdebi-core
  1199. chroot "$rootdir" gdebi -n /tmp/"$(basename $CUSTOM_SETUP)"
  1200. fi
  1201. chroot "$rootdir" apt-get install -y sudo git dialog toilet build-essential openssh-server
  1202. chroot "$rootdir" apt-get install -y avahi-daemon avahi-utils avahi-discover avahi-autoipd
  1203. chroot "$rootdir" apt-get install -y iptables dnsutils net-tools network-manager iputils-ping
  1204. chroot "$rootdir" apt-get install -y libnss-mdns libnss-myhostname libnss-gw-name nano man ntp
  1205. chroot "$rootdir" apt-get install -y locales locales-all debconf wireless-tools wpasupplicant
  1206. sed -i "s|#host-name=.*|host-name=${PROJECT_NAME}|g" $rootdir/etc/avahi/avahi-daemon.conf
  1207. sed -i "s|host-name=.*|host-name=${PROJECT_NAME}|g" $rootdir/etc/avahi/avahi-daemon.conf
  1208. chroot "$rootdir" /bin/bash -x <<EOF
  1209. git clone $PROJECT_REPO /root/$PROJECT_NAME
  1210. cd /root/$PROJECT_NAME
  1211. make install
  1212. EOF
  1213. chroot "$rootdir" ${PROJECT_NAME}-image-hardware-setup 2>&1 | \
  1214. tee $rootdir/var/log/${PROJECT_NAME}-image-hardware-setup.log
  1215. rm $rootdir/usr/sbin/policy-rc.d
  1216. # Set up HRNG for systems known to have one
  1217. # Otherwise install haveged
  1218. if [[ "$MACHINE" != "beaglebone" ]]; then
  1219. chroot $rootdir apt-get -y install haveged
  1220. else
  1221. chroot $rootdir apt-get -y install rng-tools
  1222. sed -i 's|#HRNGDEVICE=/dev/hwrng|HRNGDEVICE=/dev/hwrng|g' $rootdir/etc/default/rng-tools
  1223. fi
  1224. # copy u-boot to beginning of image
  1225. case "$MACHINE" in
  1226. beaglebone)
  1227. dd if=$rootdir/usr/lib/u-boot/am335x_boneblack/MLO of="$image" \
  1228. count=1 seek=1 conv=notrunc bs=128k
  1229. dd if=$rootdir/usr/lib/u-boot/am335x_boneblack/u-boot.img of="$image" \
  1230. count=2 seek=1 conv=notrunc bs=384k
  1231. ;;
  1232. cubieboard2)
  1233. dd if=$rootdir/usr/lib/u-boot/Cubieboard2/u-boot-sunxi-with-spl.bin of="$image" \
  1234. seek=8 conv=notrunc bs=1k
  1235. ;;
  1236. a20-olinuxino-lime)
  1237. dd if=$rootdir/usr/lib/u-boot/A20-OLinuXino-Lime/u-boot-sunxi-with-spl.bin \
  1238. of="$image" seek=8 conv=notrunc bs=1k
  1239. ;;
  1240. esac
  1241. if $use_eatmydata ; then
  1242. disable_eatmydata_override
  1243. fi
  1244. set_apt_sources $MIRROR
  1245. chroot "$rootdir" apt-get update
  1246. configure_ssh
  1247. configure_networking
  1248. admin_user_sudo
  1249. create_generic_image
  1250. atheros_wifi
  1251. continue_installation
  1252. initialise_mesh
  1253. configure_wifi
  1254. configure_user_interface
  1255. cd /
  1256. echo $"info: killing leftover processes in chroot"
  1257. fuser -mvk $rootdir/. || true
  1258. exit 0